// Copyright (c) 1994-2010: Wieger Wesselink <j.w.wesselink@tue.nl>
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#ifndef EDGE
#define EDGE

#include <int2.h>

class Edge:public int2 {
  public:
    int count;
    Edge() : int2() { count=1; }
    Edge(const int2 ed) : int2(ed) { count=1; }
    Edge(int a,int b) : int2(a,b) { count=1; }
    Edge(const Edge &ed) : int2(ed) { count=ed.count; }

    void sort() { if (X[0]>X[1]) { int h=X[0];X[0]=X[1];X[1]=h; } }
      
    bool operator<(const Edge ed) 
      { return ((X[0]<ed[0])||((X[0]==ed[0])&&(X[1]<ed[1]))); }
    bool operator<=(const Edge ed)
      { return ((X[0]<ed[0])||((X[0]==ed[0])&&(X[1]<=ed[1]))); }
    Edge operator=(const Edge ed) 
      { X[0]=ed[0];X[1]=ed[1];count=ed.count; return *this; }
    bool operator==(const Edge ed)
      { return ((X[0]==ed[0])&&(X[1]==ed[1])); }
    bool operator>=(const Edge ed)
      { return ((X[0]>ed[0])||((X[0]==ed[0])&&(X[1]>=ed[1]))); }
    bool operator>(const Edge ed)
      { return ((X[0]>ed[0])||((X[0]==ed[0])&&(X[1]>ed[1]))); }
};

#endif

