// Copyright (c) 1994-2010: Wieger Wesselink <j.w.wesselink@tue.nl>
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#include <math.h>
#include <cstdlib>
#include <assert.h>
#include "vbspline.h"
#include "constrai.h"
#include "potentia.h"
#include "hwhead.h"




void maak_eqn_sys(DoubleMatrix &gezocht ,DoubleVector &rhs,
  double weight,
  double alpha ,
  int N )
{
  VariationalBSpline curve;

   for (int i=0; i<N; i++) {
    double3* point = new double3(
    double3((100.0*i)/N, 0, 0) + 5.0*double3(drand48(), drand48(), drand48())
				 );
    curve.InsertControlPoint(point);
  }

  // creeer een punt attractor
  double t0 = 2 + 0.4*(N-3);
  double3 point(1,2,3);
  
  SparseQuadraticFunction* pointattr = curve.GetPointToPointAttractor(weight, t0, point);

  DoubleMatrix A;
  DoubleVector B;
  double C=0;
    pointattr->GetMatrices(A,B,C); 
   A.Fill(0);
   B.Fill(0);
   gezocht = A;
  rhs =B;

}

int main(int argc, char *argv[]){

  double w=0;
  double alpha;
  DoubleMatrix MM;

  alpha =0; {
    std::cout << "alpha " << alpha << std::endl;
    for (int i = 5; i < 80; i*=2) {
      DoubleMatrix M; DoubleVector rhs;
      maak_eqn_sys(M, rhs, w, alpha, i);
      DoubleMatrix MM = M;
      DoubleVector V = MM.EigenValues();
      double c = V[0];
      printf("N = %d, alpha = %f: Cond = %f\n", i,alpha,c);
    }
  }

  alpha =0.5; {
    std::cout << "alpha " << alpha << std::endl;
    for (int i = 5; i < 40; i*=2) {
      DoubleMatrix M; DoubleVector rhs;
      maak_eqn_sys(M, rhs, w, alpha, i);
      MM = M;
      DoubleVector V = MM.EigenValues();
      double c = V[0];
      printf("N = %d, alpha = %f: Cond = %f\n", i,alpha,c);
    }
  }

  alpha =1.0; {
    std::cout << "alpha " << alpha << std::endl;
    for (int i = 5; i < 80; i*=2) {
      DoubleMatrix M; DoubleVector rhs;
      maak_eqn_sys(M, rhs, w, alpha, i);
      DoubleMatrix MM = M;
      DoubleVector V = MM.EigenValues();
      double c = V[0];
      printf("N = %d, alpha = %f: Cond = %f\n", i,alpha,c);
    }
  }

  return 0;
}



//  for (double alpha = 0; alpha <= 1.0; alpha += 0.5) {       

