// Copyright (c) 1994-2010: Wieger Wesselink <j.w.wesselink@tue.nl>
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#include <iostream>
#include "vbspline.h"
#include "constrai.h"

int main(int argc, char *argv[])
{
  int num;
  double len;
  char FileName[180];

  std::cout << "This program creates a uniform B-spline curve with the control"
       << " points on a line." << std::endl;
  std::cout << "  number of control points "; std::cin >> num;
  std::cout << "  length of the line       "; std::cin >> len;
  std::cout << "  output file:             "; std::cin >> FileName;

  VariationalBSpline curve;
  curve.SetLine(num, len);

  double3 p0 = curve.GetPoint(0); 
  double3 t0 = curve.GetTangent(0); 
  double3 p1 = curve.GetPoint(1);
  double3 t1 = curve.GetTangent(0); 
  curve.PointToPointConstraints.Insert(new PointToPointConstraint(0, p0)); 
  curve.PointToPointConstraints.Insert(new PointToPointConstraint(1, p1)); 
  curve.TangentToVectorConstraints.Insert(new TangentToVectorConstraint(0, t0));
  curve.TangentToVectorConstraints.Insert(new TangentToVectorConstraint(1, t1));

  curve.SaveFile(FileName);

  return 0;
}

