// Copyright (c) 1994-2010: Wieger Wesselink <j.w.wesselink@tue.nl>
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#include <iostream>
#include <geotyp.h>
#include <newton.h>
#include "distfunc.h"

int main(int argc, char *argv[])
{
  BSpline curve("curve.dat");

  double3 r = curve(0.5);
  double3 s(0,1,0);
  Line3D line(r,s);

  double t = curve.FindParameter(line);
  LineDistFunc f(curve, line);
  if (f.MinimizeNewton(t))
    std::cout << "t = " << t << std::endl;
  else std::cout << "geen punt gevonden" << std::endl;

  return 0;
}





//  double3 P = r + double3(0,0,0.5);
//  PointDistFunc g(curve,P);
