// Copyright (c) 1994-2010: Wieger Wesselink <j.w.wesselink@tue.nl>
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#include <cstdlib>
#include <iostream>
#include <fstream>
#include "vbspline.h"

int main(int argc, char *argv[])
{
  std::ifstream from(argv[1]);
  if (!from) {
    std::cout << "Could not open file " << argv[1] << std::endl;
    exit(1);
  }

  double alpha = 0;
  if (argc > 1)
    alpha = atof(argv[2]);

  std::cout << "alpha = " << alpha << std::endl;

  // define a curve
  VariationalBSpline curve;
  from >> curve;
  from.close();

  std::cout << "Minimizing energy..." << std::endl;
  curve.MinEnergy(alpha);
  std::cout << " done!" << std::endl;

  std::cout << "Saving curve in file " << argv[1] << "..." << flush;
  std::ofstream to(argv[1]);
  to << curve;
  std::cout << " done!" << std::endl;

  return 0;
}

