// Copyright (c) 1994-2010: Wieger Wesselink <j.w.wesselink@tue.nl>
//
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#include <iostream>
#include <bvalues.h>
#include <fstream>
#include <numalg.h>
#include "vbspline.h"
#include "potent.h"

int main()
{
  ReadEnergyMatrices();
/*
  std::cout << "steepest descent method" << std::endl;
  {
    VariationalBSpline B("curve.dat");
    if (B.MinimizeStedesc(20, 1e-10))
      B.CheckConstraints();
    B.ShowControlPoints();
  }
*/
  std::cout << "conjugate gradient method" << std::endl;
  {
    VariationalBSpline B("curve.dat");
    if (B.MinimizeConjugateGradient(20, 1e-10))
      B.CheckConstraints();
    B.ShowControlPoints();
  }

  DoubleMatrix A;
  DoubleVector B;

  std::ifstream from("conjgrad.mtx");
  from >> B >> A;
  from.close();

  SparseDoubleMatrix AA(A);

  DoubleVector X(A.NumCols());
  X.MakeZero();

  DoubleVector ev = A.EigenValues();
  std::cout << "ev = " << ev << std::endl;

  std::cout << "LU decomposition" << std::endl;
  {
    VariationalBSpline B("curve.dat");
//    B.Show();
    if (B.MinimizeLUDecomp())
      B.CheckConstraints();
//    B.ShowControlPoints();
  }

}
